import greenfoot.*;
import java.awt.Color;
import java.util.*;

public class Universe extends Actor
{    
    public static View view = new View(0f,0f,0f, 0f,0f,0f);
    public vector v0 = new vector(-1f,1f,6f); //Back face vertices
    public vector v1 = new vector(1f,1f,6f);
    public vector v4 = new vector(-1f,-1f,6f);
    public vector v5 = new vector(1f,-1f,6f);
    public vector v2 = new vector(-1f,1f,4f); //Front face vertices
    public vector v3 = new vector(1f,1f,4f);
    public vector v6 = new vector(-1f,-1f,4f);
    public vector v7 = new vector(1f,-1f,4f); //hi
    public GreenfootImage space = new GreenfootImage("space.jpg");
    public boolean gameStart = false;
    public boolean modelsLoaded = false;
    public int count = 0;
    
    //Pyramid data
    public Object pyramid1 = new Object(new vector(0f,0f,0f), new vector(0f,0f,0f),
                                new vector[]{new vector(1.000000f,-1.000000f,-1.000000f),
                                             new vector(1.000000f,-1.000000f,1.000000f),
                                             new vector(-1.000000f,-1.000000f,1.000000f),
                                             new vector(-1.000000f,-1.000000f,-1.000000f),
                                             new vector(-0.000000f,1.000000f,0.000000f)},
                                             new int[][]{{1,5,2,1},
                                                         {2,5,3,2},
                                                         {3,5,4,3},
                                                         {5,1,4,4},
                                                         {1,2,3,5},
                                                         {1,3,4,5}},
                                             new vector[]{new vector(0.894427f,0.447214f,0.000000f),
                                                          new vector(-0.000000f,0.447214f,0.894427f),
                                                          new vector(-0.894427f,0.447214f,-0.000000f),
                                                          new vector(0.000000f,0.447214f,-0.894427f),
                                                          new vector(-0.000000f,-1.000000f,0.000000f)},
                                             new Color[]{Color.RED, Color.ORANGE, Color.YELLOW, Color.GREEN, Color.BLUE,Color.MAGENTA});
    public Object pyramid2 = new Object(new vector(0f,0f,10f), new vector(0f,0f,0f),
                                new vector[]{new vector(1.000000f,-1.000000f,-1.000000f),
                                             new vector(1.000000f,-1.000000f,1.000000f),
                                             new vector(-1.000000f,-1.000000f,1.000000f),
                                             new vector(-1.000000f,-1.000000f,-1.000000f),
                                             new vector(-0.000000f,1.000000f,0.000000f)},
                                             new int[][]{{1,5,2,1},
                                                         {2,5,3,2},
                                                         {3,5,4,3},
                                                         {5,1,4,4},
                                                         {1,2,3,5},
                                                         {1,3,4,5}},
                                             new vector[]{new vector(0.894427f,0.447214f,0.000000f),
                                                          new vector(-0.000000f,0.447214f,0.894427f),
                                                          new vector(-0.894427f,0.447214f,-0.000000f),
                                                          new vector(0.000000f,0.447214f,-0.894427f),
                                                          new vector(-0.000000f,-1.000000f,0.000000f)},
                                             new Color[]{Color.RED, Color.ORANGE, Color.YELLOW, Color.GREEN, Color.BLUE,Color.MAGENTA});
    public Object pyramid3 = new Object(new vector(2f,0f,10f), new vector(0f,0f,0f),
                                new vector[]{new vector(1.000000f,-1.000000f,-1.000000f),
                                             new vector(1.000000f,-1.000000f,1.000000f),
                                             new vector(-1.000000f,-1.000000f,1.000000f),
                                             new vector(-1.000000f,-1.000000f,-1.000000f),
                                             new vector(-0.000000f,1.000000f,0.000000f)},
                                             new int[][]{{1,5,2,1},
                                                         {2,5,3,2},
                                                         {3,5,4,3},
                                                         {5,1,4,4},
                                                         {1,2,3,5},
                                                         {1,3,4,5}},
                                             new vector[]{new vector(0.894427f,0.447214f,0.000000f),
                                                          new vector(-0.000000f,0.447214f,0.894427f),
                                                          new vector(-0.894427f,0.447214f,-0.000000f),
                                                          new vector(0.000000f,0.447214f,-0.894427f),
                                                          new vector(-0.000000f,-1.000000f,0.000000f)},
                                             new Color[]{Color.RED, Color.ORANGE, Color.YELLOW, Color.GREEN, Color.BLUE,Color.MAGENTA});
    public Object[] stack = new Object[1];
    
    public static float[][] fnSortHeap(float array[][], int arr_ubound) //http://www.roseindia.net/java/beginners/arrayexamples/heapSort.shtml
    {
        int i, o;
        int lChild, rChild, mChild, root;
        float[] temp;
        root = (arr_ubound-1)/2;
        
        for(o = root; o >= 0; o--)
        {
            for(i=root;i>=0;i--)
            {
                lChild = (2*i)+1;
                rChild = (2*i)+2;
                if((lChild <= arr_ubound) && (rChild <= arr_ubound))
                {
                    if(array[rChild][0] >= array[lChild][0])
                        mChild = rChild;
                    else
                        mChild = lChild;
                }
                else
                {
                    if(rChild > arr_ubound)
                        mChild = lChild;
                    else
                        mChild = rChild;
                }
                
                if(array[i][0] < array[mChild][0])
                {
                    temp = array[i];
                    array[i] = array[mChild];
                    array[mChild] = temp;
                }
            }
        }
        temp = array[0];
        array[0] = array[arr_ubound];
        array[arr_ubound] = temp;
        return array;
    }

    public void act() 
    {
        if(!gameStart)
        {
            //System.out.println("\f");
            gameStart = true;
            for(int i = 0;i<stack.length;i++)
            {
                stack[i] = //new Object(new vector(Greenfoot.getRandomNumber(0)-0f,Greenfoot.getRandomNumber(0)-0f,5f), new vector(0f,0f,0f),
                             new Object(new vector(0f,0f,5f), new vector(0f,0f,0f),
                                new vector[]{new vector(0.498058,-0.185839,-0.398986),
                                            new vector(0.498058,-0.185839,-0.628183),
                                            new vector(1.269019,1.470014,-0.578490),
                                            new vector(1.269018,1.470014,-0.448679),
                                            new vector(-0.272903,1.470014,-0.448679),
                                            new vector(-0.272903,1.470014,-0.578490),
                                            new vector(0.497969,1.295308,-0.345400),
                                            new vector(0.497770,1.294566,-0.675877),
                                            new vector(1.341576,0.635485,-0.365599),
                                            new vector(1.341577,0.635485,-0.661570),
                                            new vector(-0.345461,0.635485,-0.365599),
                                            new vector(-0.345461,0.635485,-0.661570),
                                            new vector(0.498058,0.635150,-0.070129),
                                            new vector(0.498058,0.635150,-0.957040),
                                            new vector(0.847517,1.544292,-0.350765),
                                            new vector(0.181948,1.543814,-0.345704),
                                            new vector(0.847517,1.544292,-0.676403),
                                            new vector(0.181777,1.543072,-0.675574),
                                            new vector(0.984604,0.117562,-0.414843),
                                            new vector(1.407403,1.127776,-0.350765),
                                            new vector(0.984604,0.117562,-0.612326),
                                            new vector(1.407403,1.127776,-0.676403),
                                            new vector(0.011511,0.117562,-0.414844),
                                            new vector(-0.411287,1.127776,-0.350766),
                                            new vector(0.011512,0.117562,-0.612326),
                                            new vector(-0.411287,1.127776,-0.676404),
                                            new vector(0.498070,1.095040,-0.026451),
                                            new vector(0.950628,0.635485,-0.070965),
                                            new vector(0.498058,0.116751,-0.225592),
                                            new vector(0.045487,0.635485,-0.070966),
                                            new vector(0.498058,0.116751,-0.801577),
                                            new vector(0.950629,0.635485,-0.956204),
                                            new vector(0.498058,1.094988,-1.001485),
                                            new vector(0.045488,0.635485,-0.956204),
                                            new vector(0.981573,1.128187,-0.026605),
                                            new vector(0.759851,0.116450,-0.226599),
                                            new vector(0.014554,1.128240,-0.027372),
                                            new vector(0.236265,0.116450,-0.226599),
                                            new vector(0.759851,0.116450,-0.800570),
                                            new vector(0.981574,1.128187,-1.000564),
                                            new vector(0.236265,0.116450,-0.800571),
                                            new vector(0.014543,1.128187,-1.000564),
                                            new vector(0.678898,1.446485,-0.349992),
                                            new vector(1.035094,1.580296,-0.358639),
                                            new vector(0.349988,1.442634,-0.354309),
                                            new vector(-0.106081,1.568854,-0.358163),
                                            new vector(0.678894,1.446467,-0.676694),
                                            new vector(1.035094,1.580296,-0.668530),
                                            new vector(0.348545,1.436191,-0.673710),
                                            new vector(-0.106086,1.568836,-0.668523),
                                            new vector(1.215622,0.385336,-0.385622),
                                            new vector(1.421105,0.884697,-0.350468),
                                            new vector(1.341012,1.341651,-0.358639),
                                            new vector(1.215622,0.385336,-0.641547),
                                            new vector(1.421105,0.884697,-0.676701),
                                            new vector(1.341012,1.341651,-0.668530),
                                            new vector(-0.219506,0.385336,-0.385622),
                                            new vector(0.229985,-0.070636,-0.416728),
                                            new vector(-0.424989,0.884697,-0.350468),
                                            new vector(-0.344896,1.341651,-0.358639),
                                            new vector(-0.219506,0.385336,-0.641547),
                                            new vector(0.229985,-0.070636,-0.610441),
                                            new vector(-0.424989,0.884697,-0.676701),
                                            new vector(-0.344896,1.341651,-0.668530),
                                            new vector(0.498058,0.880346,-0.024779),
                                            new vector(0.498286,1.221410,-0.056225),
                                            new vector(0.724497,0.635063,-0.070144),
                                            new vector(1.138216,0.635235,-0.113320),
                                            new vector(0.498058,0.384974,-0.130493),
                                            new vector(0.271618,0.635063,-0.070144),
                                            new vector(-0.142101,0.635235,-0.113321),
                                            new vector(0.498058,0.384974,-0.896676),
                                            new vector(1.138217,0.635235,-0.913854),
                                            new vector(0.724498,0.635063,-0.957025),
                                            new vector(0.498058,0.880346,-1.002391),
                                            new vector(0.498043,1.220366,-0.976797),
                                            new vector(-0.142100,0.635235,-0.913855),
                                            new vector(0.271619,0.635063,-0.957025),
                                            new vector(0.933514,1.331580,-0.090763),
                                            new vector(1.186100,1.130688,-0.073212),
                                            new vector(0.992635,0.884892,-0.025700),
                                            new vector(0.739558,1.109897,-0.025700),
                                            new vector(0.882869,0.384969,-0.131232),
                                            new vector(0.862967,0.088857,-0.246269),
                                            new vector(0.622953,0.091033,-0.225948),
                                            new vector(0.062830,1.332561,-0.096131),
                                            new vector(0.256788,1.110892,-0.032043),
                                            new vector(0.003480,0.884892,-0.025701),
                                            new vector(-0.189984,1.130688,-0.073213),
                                            new vector(0.113246,0.384969,-0.131232),
                                            new vector(0.373163,0.091033,-0.225948),
                                            new vector(0.133149,0.088857,-0.246269),
                                            new vector(0.862967,0.088857,-0.780900),
                                            new vector(0.882870,0.384969,-0.895937),
                                            new vector(0.622953,0.091033,-0.801221),
                                            new vector(0.992636,0.884892,-1.001469),
                                            new vector(1.186100,1.130688,-0.953962),
                                            new vector(0.933514,1.331580,-0.936812),
                                            new vector(0.739559,1.109897,-1.001469),
                                            new vector(0.373163,0.091033,-0.801221),
                                            new vector(0.113247,0.384969,-0.895937),
                                            new vector(0.133149,0.088857,-0.780901),
                                            new vector(0.003481,0.884892,-1.001469),
                                            new vector(0.256550,1.109865,-1.001462),
                                            new vector(0.062587,1.331516,-0.936799),
                                            new vector(-0.189984,1.130688,-0.953962),
                                            new vector(0.331494,-0.051758,-0.709204),
                                            new vector(0.664622,-0.051758,-0.709204),
                                            new vector(0.498058,-0.049962,-0.714513),
                                            new vector(0.766131,-0.070636,-0.610441),
                                            new vector(0.331494,-0.051758,-0.317965),
                                            new vector(0.664622,-0.051758,-0.317965),
                                            new vector(0.498058,-0.049962,-0.312657),
                                            new vector(0.766131,-0.070636,-0.416728),
                                            new vector(1.129742,1.346789,-0.131343),
                                            new vector(1.198377,0.885038,-0.072381),
                                            new vector(0.714038,1.265021,-0.090315),
                                            new vector(0.745526,0.882410,-0.024795),
                                            new vector(1.039796,0.381681,-0.168066),
                                            new vector(0.689830,0.381825,-0.130515),
                                            new vector(0.283934,1.272924,-0.110402),
                                            new vector(0.250596,0.882436,-0.025179),
                                            new vector(-0.133621,1.346815,-0.131678),
                                            new vector(-0.202261,0.885038,-0.072381),
                                            new vector(0.306286,0.381825,-0.130515),
                                            new vector(-0.043680,0.381681,-0.168066),
                                            new vector(1.039796,0.381681,-0.859109),
                                            new vector(0.689830,0.381825,-0.896655),
                                            new vector(1.198377,0.885038,-0.954793),
                                            new vector(1.129743,1.346789,-0.896217),
                                            new vector(0.745526,0.882409,-1.002374),
                                            new vector(0.714033,1.264995,-0.937610),
                                            new vector(0.306286,0.381825,-0.896655),
                                            new vector(-0.043680,0.381681,-0.859109),
                                            new vector(0.250590,0.882409,-1.002374),
                                            new vector(0.281798,1.263788,-0.937287),
                                            new vector(-0.202261,0.885038,-0.954794),
                                            new vector(-0.133627,1.346789,-0.896217)},
                                             new int[][]{{112,1,1,1,114,1},
                                                {114,2,84,2,112,2},
                                                {36,3,112,3,84,3},
                                                {84,4,114,4,19,4},
                                                {113,5,1,5,112,5},
                                                {112,6,85,6,113,6},
                                                {29,7,113,7,85,7},
                                                {85,8,112,8,36,8},
                                                {111,9,1,9,113,9},
                                                {113,10,91,10,111,10},
                                                {38,11,111,11,91,11},
                                                {91,12,113,12,29,12},
                                                {58,13,1,13,111,13},
                                                {111,14,92,14,58,14},
                                                {23,15,58,15,92,15},
                                                {92,16,111,16,38,16},
                                                {93,17,21,17,110,17},
                                                {110,18,108,18,93,18},
                                                {39,19,93,19,108,19},
                                                {108,20,110,20,2,20},
                                                {95,21,39,21,108,21},
                                                {108,22,109,22,95,22},
                                                {31,23,95,23,109,23},
                                                {109,24,108,24,2,24},
                                                {100,25,31,25,109,25},
                                                {109,26,107,26,100,26},
                                                {41,27,100,27,107,27},
                                                {107,28,109,28,2,28},
                                                {102,29,41,29,107,29},
                                                {107,30,62,30,102,30},
                                                {25,31,102,31,62,31},
                                                {62,32,107,32,2,32},
                                                {16,33,45,33,18,33},
                                                {45,34,49,34,18,34},
                                                {7,35,8,35,45,35},
                                                {8,36,49,36,45,36},
                                                {24,37,60,37,64,37},
                                                {24,37,64,37,26,37},
                                                {24,38,26,38,63,38},
                                                {24,38,63,38,59,38},
                                                {23,39,25,39,58,39},
                                                {25,40,62,40,58,40},
                                                {23,41,57,41,61,41},
                                                {23,41,61,41,25,41},
                                                {20,42,22,42,56,42},
                                                {20,43,56,43,53,43},
                                                {20,44,52,44,22,44},
                                                {52,44,55,44,22,44},
                                                {19,45,114,45,110,45},
                                                {19,45,110,45,21,45},
                                                {19,46,21,46,54,46},
                                                {19,46,54,46,51,46},
                                                {16,47,18,47,46,47},
                                                {18,48,50,48,46,48},
                                                {15,49,44,49,17,49},
                                                {44,49,48,49,17,49},
                                                {15,50,17,50,47,50},
                                                {15,51,47,51,43,51},
                                                {11,52,59,52,63,52},
                                                {11,53,63,53,12,53},
                                                {11,54,12,54,61,54},
                                                {11,54,61,54,57,54},
                                                {9,55,10,55,55,55},
                                                {9,56,55,56,52,56},
                                                {9,57,51,57,54,57},
                                                {9,58,54,58,10,58},
                                                {7,59,43,59,8,59},
                                                {43,60,47,60,8,60},
                                                {5,61,6,61,64,61},
                                                {5,62,64,62,60,62},
                                                {5,63,46,63,50,63},
                                                {5,64,50,64,6,64},
                                                {3,65,4,65,53,65},
                                                {3,66,53,66,56,66},
                                                {3,67,48,67,4,67},
                                                {48,68,44,68,4,68},
                                                {1,69,2,69,110,69},
                                                {1,69,110,69,114,69},
                                                {1,70,58,70,62,70},
                                                {1,70,62,70,2,70},
                                                {50,71,138,71,64,71},
                                                {50,72,64,72,6,72},
                                                {138,73,106,73,64,73},
                                                {106,74,26,74,64,74},
                                                {18,75,105,75,50,75},
                                                {105,76,138,76,50,76},
                                                {105,77,42,77,138,77},
                                                {42,78,106,78,138,78},
                                                {106,79,137,79,26,79},
                                                {137,80,63,80,26,80},
                                                {137,81,77,81,12,81},
                                                {137,82,12,82,63,82},
                                                {42,83,103,83,106,83},
                                                {103,84,137,84,106,84},
                                                {103,85,34,85,77,85},
                                                {103,86,77,86,137,86},
                                                {49,87,136,87,18,87},
                                                {136,88,105,88,18,88},
                                                {136,89,104,89,105,89},
                                                {104,90,42,90,105,90},
                                                {8,91,76,91,136,91},
                                                {8,92,136,92,49,92},
                                                {76,93,33,93,104,93},
                                                {76,94,104,94,136,94},
                                                {104,95,135,95,103,95},
                                                {104,96,103,96,42,96},
                                                {135,97,78,97,34,97},
                                                {135,98,34,98,103,98},
                                                {33,99,75,99,135,99},
                                                {33,100,135,100,104,100},
                                                {75,101,14,101,78,101},
                                                {75,102,78,102,135,102},
                                                {77,103,134,103,61,103},
                                                {77,104,61,104,12,104},
                                                {134,105,102,105,25,105},
                                                {134,106,25,106,61,106},
                                                {34,107,101,107,134,107},
                                                {34,108,134,108,77,108},
                                                {101,109,41,109,102,109},
                                                {101,110,102,110,134,110},
                                                {78,111,133,111,101,111},
                                                {78,112,101,112,34,112},
                                                {133,113,100,113,41,113},
                                                {133,114,41,114,101,114},
                                                {14,115,72,115,133,115},
                                                {14,116,133,116,78,116},
                                                {72,117,31,117,100,117},
                                                {72,118,100,118,133,118},
                                                {47,119,132,119,8,119},
                                                {132,120,76,120,8,120},
                                                {132,121,99,121,76,121},
                                                {99,122,33,122,76,122},
                                                {17,123,98,123,47,123},
                                                {98,124,132,124,47,124},
                                                {98,125,40,125,99,125},
                                                {98,126,99,126,132,126},
                                                {99,127,131,127,33,127},
                                                {131,128,75,128,33,128},
                                                {131,129,74,129,75,129},
                                                {74,130,14,130,75,130},
                                                {40,131,96,131,99,131},
                                                {96,132,131,132,99,132},
                                                {96,133,32,133,131,133},
                                                {32,134,74,134,131,134},
                                                {48,135,130,135,98,135},
                                                {48,136,98,136,17,136},
                                                {130,137,97,137,40,137},
                                                {130,138,40,138,98,138},
                                                {3,139,56,139,130,139},
                                                {3,140,130,140,48,140},
                                                {56,141,22,141,97,141},
                                                {56,142,97,142,130,142},
                                                {97,143,129,143,96,143},
                                                {97,144,96,144,40,144},
                                                {129,145,73,145,96,145},
                                                {73,146,32,146,96,146},
                                                {22,147,55,147,129,147},
                                                {22,148,129,148,97,148},
                                                {55,149,10,149,129,149},
                                                {10,150,73,150,129,150},
                                                {74,151,128,151,14,151},
                                                {128,152,72,152,14,152},
                                                {128,153,95,153,72,153},
                                                {95,154,31,154,72,154},
                                                {32,155,94,155,74,155},
                                                {94,156,128,156,74,156},
                                                {94,157,39,157,128,157},
                                                {39,158,95,158,128,158},
                                                {73,159,127,159,32,159},
                                                {127,160,94,160,32,160},
                                                {127,161,93,161,94,161},
                                                {93,162,39,162,94,162},
                                                {10,163,54,163,73,163},
                                                {54,164,127,164,73,164},
                                                {54,165,21,165,127,165},
                                                {21,166,93,166,127,166},
                                                {92,167,126,167,23,167},
                                                {126,168,57,168,23,168},
                                                {126,169,71,169,57,169},
                                                {71,170,11,170,57,170},
                                                {38,171,90,171,92,171},
                                                {90,172,126,172,92,172},
                                                {90,173,30,173,126,173},
                                                {30,174,71,174,126,174},
                                                {91,175,125,175,38,175},
                                                {125,176,90,176,38,176},
                                                {125,177,70,177,90,177},
                                                {70,178,30,178,90,178},
                                                {29,179,69,179,91,179},
                                                {69,180,125,180,91,180},
                                                {69,181,13,181,125,181},
                                                {13,182,70,182,125,182},
                                                {71,183,124,183,11,183},
                                                {124,184,59,184,11,184},
                                                {124,185,89,185,24,185},
                                                {124,186,24,186,59,186},
                                                {30,187,88,187,71,187},
                                                {88,188,124,188,71,188},
                                                {88,189,37,189,89,189},
                                                {88,190,89,190,124,190},
                                                {89,191,123,191,60,191},
                                                {89,192,60,192,24,192},
                                                {123,193,46,193,60,193},
                                                {46,194,5,194,60,194},
                                                {37,195,86,195,123,195},
                                                {37,196,123,196,89,196},
                                                {86,197,16,197,46,197},
                                                {86,198,46,198,123,198},
                                                {70,199,122,199,30,199},
                                                {122,200,88,200,30,200},
                                                {122,201,87,201,88,201},
                                                {87,202,37,202,88,202},
                                                {13,203,65,203,70,203},
                                                {65,204,122,204,70,204},
                                                {65,205,27,205,122,205},
                                                {27,206,87,206,122,206},
                                                {87,207,121,207,86,207},
                                                {87,208,86,208,37,208},
                                                {121,209,45,209,16,209},
                                                {121,210,16,210,86,210},
                                                {27,211,66,211,87,211},
                                                {66,212,121,212,87,212},
                                                {66,213,7,213,121,213},
                                                {7,214,45,214,121,214},
                                                {85,215,120,215,69,215},
                                                {85,216,69,216,29,216},
                                                {120,217,67,217,13,217},
                                                {120,218,13,218,69,218},
                                                {36,219,83,219,120,219},
                                                {36,220,120,220,85,220},
                                                {83,221,28,221,67,221},
                                                {83,222,67,222,120,222},
                                                {84,223,119,223,83,223},
                                                {84,224,83,224,36,224},
                                                {119,225,68,225,28,225},
                                                {119,226,28,226,83,226},
                                                {19,227,51,227,119,227},
                                                {19,228,119,228,84,228},
                                                {51,229,9,229,68,229},
                                                {51,230,68,230,119,230},
                                                {67,231,118,231,65,231},
                                                {67,232,65,232,13,232},
                                                {118,233,82,233,27,233},
                                                {118,234,27,234,65,234},
                                                {28,235,81,235,118,235},
                                                {28,236,118,236,67,236},
                                                {81,237,35,237,82,237},
                                                {81,238,82,238,118,238},
                                                {82,239,117,239,66,239},
                                                {82,240,66,240,27,240},
                                                {117,241,43,241,7,241},
                                                {117,242,7,242,66,242},
                                                {35,243,79,243,82,243},
                                                {79,244,117,244,82,244},
                                                {79,245,15,245,43,245},
                                                {79,246,43,246,117,246},
                                                {68,247,116,247,81,247},
                                                {68,248,81,248,28,248},
                                                {116,249,80,249,81,249},
                                                {80,250,35,250,81,250},
                                                {9,251,52,251,116,251},
                                                {9,252,116,252,68,252},
                                                {52,253,20,253,116,253},
                                                {20,254,80,254,116,254},
                                                {80,255,115,255,35,255},
                                                {115,256,79,256,35,256},
                                                {115,257,44,257,79,257},
                                                {44,258,15,258,79,258},
                                                {20,259,53,259,80,259},
                                                {53,260,115,260,80,260},
                                                {53,261,4,261,115,261},
                                                {4,262,44,262,115,262}},
                                             new vector[]{new vector(0.365532,-0.770050,0.522886),
                                                new vector(0.361287,-0.774427,0.519360),
                                                new vector(0.034305,-0.491956,0.869944),
                                                new vector(0.616236,-0.718598,0.322289),
                                                new vector(0.021115,-0.536147,0.843861),
                                                new vector(0.021082,-0.537212,0.843184),
                                                new vector(-0.092398,-0.460936,0.882610),
                                                new vector(0.100232,-0.518127,0.849411),
                                                new vector(-0.021115,-0.536147,0.843860),
                                                new vector(-0.021082,-0.537212,0.843184),
                                                new vector(-0.100232,-0.518127,0.849410),
                                                new vector(0.092398,-0.460936,0.882610),
                                                new vector(-0.365532,-0.770049,0.522886),
                                                new vector(-0.361287,-0.774427,0.519360),
                                                new vector(-0.616236,-0.718598,0.322289),
                                                new vector(-0.034305,-0.491956,0.869944),
                                                new vector(0.616236,-0.718598,-0.322289),
                                                new vector(0.361288,-0.774427,-0.519360),
                                                new vector(0.034305,-0.491955,-0.869944),
                                                new vector(0.365532,-0.770050,-0.522886),
                                                new vector(0.100233,-0.518126,-0.849411),
                                                new vector(0.021082,-0.537212,-0.843184),
                                                new vector(-0.092398,-0.460936,-0.882610),
                                                new vector(0.021115,-0.536147,-0.843860),
                                                new vector(0.092398,-0.460936,-0.882610),
                                                new vector(-0.021082,-0.537212,-0.843184),
                                                new vector(-0.100231,-0.518127,-0.849410),
                                                new vector(-0.021115,-0.536147,-0.843860),
                                                new vector(-0.034305,-0.491956,-0.869944),
                                                new vector(-0.361287,-0.774427,-0.519360),
                                                new vector(-0.616236,-0.718598,-0.322289),
                                                new vector(-0.365532,-0.770049,-0.522887),
                                                new vector(0.515747,0.856738,-0.002194),
                                                new vector(0.539642,0.841670,-0.019416),
                                                new vector(0.705597,0.708610,-0.002014),
                                                new vector(0.688150,0.725352,-0.017741),
                                                new vector(-0.955044,0.296464,-0.000001),
                                                new vector(-0.998415,0.056278,-0.000001),
                                                new vector(-0.652658,-0.757652,-0.000001),
                                                new vector(-0.652659,-0.757652,-0.000000),
                                                new vector(-0.757161,-0.653228,-0.000001),
                                                new vector(0.955044,0.296465,0.000001),
                                                new vector(0.955044,0.296465,0.000002),
                                                new vector(0.998415,0.056278,0.000001),
                                                new vector(0.652658,-0.757652,0.000000),
                                                new vector(0.757161,-0.653228,0.000001),
                                                new vector(0.086708,0.996231,-0.002285),
                                                new vector(0.089144,0.996019,-0.000059),
                                                new vector(-0.188503,0.982073,-0.000000),
                                                new vector(-0.501807,0.864980,-0.000001),
                                                new vector(-0.501748,0.865014,-0.000041),
                                                new vector(-0.952668,-0.304014,-0.000001),
                                                new vector(-0.952668,-0.304013,-0.000001),
                                                new vector(-0.893166,-0.449727,-0.000001),
                                                new vector(0.952668,-0.304014,0.000001),
                                                new vector(0.952668,-0.304013,0.000001),
                                                new vector(0.893166,-0.449726,0.000001),
                                                new vector(0.893166,-0.449727,0.000001),
                                                new vector(-0.641213,0.767362,-0.001337),
                                                new vector(-0.642591,0.766210,-0.000034),
                                                new vector(-0.872187,0.489172,-0.000001),
                                                new vector(-0.872188,0.489171,-0.000001),
                                                new vector(-0.509720,0.860340,-0.000042),
                                                new vector(-0.509680,0.860364,-0.000001),
                                                new vector(0.872187,0.489173,0.000003),
                                                new vector(0.872188,0.489171,0.000002),
                                                new vector(0.426430,0.904521,0.000002),
                                                new vector(0.426431,0.904520,0.000000),
                                                new vector(0.394832,-0.918754,0.000000),
                                                new vector(-0.394831,-0.918754,-0.000000),
                                                new vector(-0.584951,0.614899,-0.528897),
                                                new vector(-0.620933,0.652719,-0.434051),
                                                new vector(-0.690780,0.349318,-0.633087),
                                                new vector(-0.756924,0.257081,-0.600813),
                                                new vector(0.052648,0.764155,-0.642880),
                                                new vector(-0.086813,0.718454,-0.690136),
                                                new vector(-0.166396,0.330649,-0.928969),
                                                new vector(-0.208208,0.302814,-0.930028),
                                                new vector(-0.781438,0.041161,-0.622624),
                                                new vector(-0.779767,0.044719,-0.624471),
                                                new vector(-0.747811,-0.278841,-0.602516),
                                                new vector(-0.750071,-0.275856,-0.601080),
                                                new vector(-0.221980,0.013716,-0.974955),
                                                new vector(-0.221207,0.014356,-0.975121),
                                                new vector(-0.215069,-0.209347,-0.953897),
                                                new vector(-0.216521,-0.208454,-0.953764),
                                                new vector(0.449343,0.691245,-0.565924),
                                                new vector(0.217170,0.707744,-0.672262),
                                                new vector(0.111279,0.366826,-0.923610),
                                                new vector(0.018802,0.295137,-0.955270),
                                                new vector(0.149550,0.960032,-0.236587),
                                                new vector(0.572849,0.611936,-0.545325),
                                                new vector(0.011806,0.193188,-0.981091),
                                                new vector(-0.087616,0.395550,-0.914256),
                                                new vector(-0.003622,0.004105,-0.999985),
                                                new vector(-0.003415,0.003872,-0.999987),
                                                new vector(-0.003910,-0.180656,-0.983539),
                                                new vector(-0.005406,-0.179452,-0.983752),
                                                new vector(-0.000032,0.004218,-0.999991),
                                                new vector(0.000150,0.004006,-0.999992),
                                                new vector(0.000004,-0.181870,-0.983323),
                                                new vector(-0.001570,-0.180464,-0.983580),
                                                new vector(-0.715692,-0.401236,-0.571659),
                                                new vector(-0.712205,-0.404529,-0.573690),
                                                new vector(-0.719667,-0.548341,-0.425913),
                                                new vector(-0.628872,-0.596917,-0.498207),
                                                new vector(-0.213539,-0.282721,-0.935131),
                                                new vector(-0.210800,-0.283797,-0.935427),
                                                new vector(-0.079077,-0.365603,-0.927406),
                                                new vector(-0.205310,-0.366368,-0.907536),
                                                new vector(-0.007406,-0.232849,-0.972485),
                                                new vector(-0.003969,-0.234909,-0.972009),
                                                new vector(-0.064745,-0.324579,-0.943640),
                                                new vector(-0.009007,-0.338325,-0.940986),
                                                new vector(0.003743,-0.234554,-0.972096),
                                                new vector(0.000024,-0.231893,-0.972741),
                                                new vector(0.065981,-0.333442,-0.940459),
                                                new vector(0.004997,-0.310780,-0.950469),
                                                new vector(-0.547845,0.650407,-0.526153),
                                                new vector(-0.155244,0.959115,-0.236637),
                                                new vector(0.085385,0.391315,-0.916287),
                                                new vector(-0.011859,0.193185,-0.981091),
                                                new vector(-0.377281,0.652285,-0.657407),
                                                new vector(-0.235368,0.782747,-0.576115),
                                                new vector(-0.018726,0.295014,-0.955309),
                                                new vector(-0.106892,0.363448,-0.925462),
                                                new vector(-0.000176,0.003975,-0.999992),
                                                new vector(0.000032,0.004218,-0.999991),
                                                new vector(0.001571,-0.180464,-0.983580),
                                                new vector(-0.000004,-0.181870,-0.983323),
                                                new vector(0.003444,0.003874,-0.999987),
                                                new vector(0.003623,0.004074,-0.999985),
                                                new vector(0.005407,-0.179452,-0.983752),
                                                new vector(0.003910,-0.180656,-0.983539),
                                                new vector(0.088472,0.713542,-0.695004),
                                                new vector(-0.116621,0.749965,-0.651116),
                                                new vector(0.208209,0.302814,-0.930028),
                                                new vector(0.166560,0.330542,-0.928978),
                                                new vector(0.556016,0.663241,-0.500956),
                                                new vector(0.519124,0.695211,-0.497184),
                                                new vector(0.756924,0.257082,-0.600812),
                                                new vector(0.690781,0.349318,-0.633087),
                                                new vector(0.221208,0.014356,-0.975121),
                                                new vector(0.221980,0.013717,-0.974955),
                                                new vector(0.216522,-0.208454,-0.953764),
                                                new vector(0.215070,-0.209347,-0.953897),
                                                new vector(0.779767,0.044718,-0.624470),
                                                new vector(0.781438,0.041162,-0.622623),
                                                new vector(0.750071,-0.275856,-0.601079),
                                                new vector(0.747812,-0.278841,-0.602516),
                                                new vector(-0.000024,-0.231893,-0.972741),
                                                new vector(-0.003742,-0.234554,-0.972096),
                                                new vector(-0.004996,-0.310780,-0.950469),
                                                new vector(-0.065980,-0.333442,-0.940459),
                                                new vector(0.003969,-0.234909,-0.972009),
                                                new vector(0.007407,-0.232849,-0.972485),
                                                new vector(0.009007,-0.338325,-0.940986),
                                                new vector(0.064746,-0.324579,-0.943640),
                                                new vector(0.210801,-0.283797,-0.935426),
                                                new vector(0.213540,-0.282721,-0.935131),
                                                new vector(0.205311,-0.366369,-0.907536),
                                                new vector(0.079076,-0.365603,-0.927406),
                                                new vector(0.712205,-0.404529,-0.573689),
                                                new vector(0.715692,-0.401237,-0.571659),
                                                new vector(0.628872,-0.596917,-0.498206),
                                                new vector(0.719667,-0.548341,-0.425913),
                                                new vector(-0.719669,-0.548335,0.425916),
                                                new vector(-0.628868,-0.596914,0.498216),
                                                new vector(-0.715685,-0.401236,0.571668),
                                                new vector(-0.712200,-0.404527,0.573698),
                                                new vector(-0.079077,-0.365603,0.927406),
                                                new vector(-0.205341,-0.366368,0.907529),
                                                new vector(-0.213570,-0.282728,0.935122),
                                                new vector(-0.210827,-0.283805,0.935418),
                                                new vector(-0.064745,-0.324579,0.943640),
                                                new vector(-0.009007,-0.338325,0.940986),
                                                new vector(-0.007407,-0.232849,0.972485),
                                                new vector(-0.003969,-0.234910,0.972009),
                                                new vector(0.065980,-0.333442,0.940459),
                                                new vector(0.004996,-0.310780,0.950469),
                                                new vector(0.003742,-0.234554,0.972096),
                                                new vector(0.000023,-0.231893,0.972741),
                                                new vector(-0.747805,-0.278841,0.602524),
                                                new vector(-0.750066,-0.275855,0.601087),
                                                new vector(-0.781432,0.041161,0.622631),
                                                new vector(-0.779761,0.044718,0.624478),
                                                new vector(-0.215097,-0.209351,0.953890),
                                                new vector(-0.216546,-0.208459,0.953757),
                                                new vector(-0.218474,0.016642,0.975701),
                                                new vector(-0.221233,0.014357,0.975115),
                                                new vector(-0.689302,0.351176,0.633670),
                                                new vector(-0.756918,0.257080,0.600820),
                                                new vector(-0.584855,0.613633,0.530470),
                                                new vector(-0.621691,0.652555,0.433212),
                                                new vector(-0.142714,0.345810,0.927388),
                                                new vector(-0.204796,0.305003,0.930071),
                                                new vector(0.037172,0.753925,0.655908),
                                                new vector(-0.073506,0.716603,0.693597),
                                                new vector(-0.003908,-0.179162,0.983812),
                                                new vector(-0.003859,-0.179202,0.983805),
                                                new vector(-0.001813,0.030085,0.999546),
                                                new vector(0.019710,0.005969,0.999788),
                                                new vector(0.000003,-0.181871,0.983323),
                                                new vector(-0.003103,-0.179096,0.983827),
                                                new vector(-0.001551,0.007788,0.999968),
                                                new vector(-0.021154,0.030602,0.999308),
                                                new vector(0.167568,0.406312,0.898238),
                                                new vector(0.040526,0.310074,0.949848),
                                                new vector(0.438337,0.677786,0.590311),
                                                new vector(0.229611,0.686088,0.690335),
                                                new vector(-0.007494,0.229339,0.973318),
                                                new vector(-0.116330,0.448133,0.886366),
                                                new vector(0.167899,0.955155,0.243901),
                                                new vector(0.562511,0.599443,0.569429),
                                                new vector(-0.004996,-0.310780,0.950469),
                                                new vector(-0.065980,-0.333442,0.940459),
                                                new vector(-0.000024,-0.231893,0.972741),
                                                new vector(-0.003742,-0.234554,0.972096),
                                                new vector(0.009007,-0.338325,0.940986),
                                                new vector(0.064746,-0.324579,0.943640),
                                                new vector(0.003969,-0.234910,0.972009),
                                                new vector(0.007406,-0.232849,0.972485),
                                                new vector(0.205341,-0.366368,0.907529),
                                                new vector(0.079077,-0.365603,0.927406),
                                                new vector(0.210826,-0.283805,0.935418),
                                                new vector(0.213569,-0.282728,0.935122),
                                                new vector(0.628868,-0.596914,0.498216),
                                                new vector(0.719669,-0.548335,0.425916),
                                                new vector(0.712200,-0.404527,0.573698),
                                                new vector(0.715685,-0.401235,0.571668),
                                                new vector(0.001571,-0.180465,0.983580),
                                                new vector(-0.000004,-0.181871,0.983323),
                                                new vector(-0.003346,0.003891,0.999987),
                                                new vector(0.000003,0.007788,0.999970),
                                                new vector(0.005405,-0.179453,0.983752),
                                                new vector(0.003909,-0.180656,0.983539),
                                                new vector(0.003443,0.003874,0.999987),
                                                new vector(0.003622,0.004074,0.999985),
                                                new vector(0.065523,0.392851,0.917265),
                                                new vector(-0.017132,0.229327,0.973199),
                                                new vector(-0.535218,0.656685,0.531325),
                                                new vector(-0.154796,0.957146,0.244764),
                                                new vector(-0.018858,0.296720,0.954778),
                                                new vector(-0.109357,0.366820,0.923842),
                                                new vector(-0.375517,0.652598,0.658105),
                                                new vector(-0.235764,0.781315,0.577894),
                                                new vector(0.216545,-0.208459,0.953757),
                                                new vector(0.215096,-0.209351,0.953890),
                                                new vector(0.221232,0.014358,0.975115),
                                                new vector(0.222005,0.013718,0.974949),
                                                new vector(0.750066,-0.275855,0.601087),
                                                new vector(0.747805,-0.278841,0.602524),
                                                new vector(0.779761,0.044718,0.624478),
                                                new vector(0.781432,0.041161,0.622632),
                                                new vector(0.208108,0.304322,0.929558),
                                                new vector(0.166261,0.332158,0.928455),
                                                new vector(0.088584,0.712974,0.695572),
                                                new vector(-0.116504,0.749480,0.651696),
                                                new vector(0.756918,0.257080,0.600820),
                                                new vector(0.689976,0.350326,0.633408),
                                                new vector(0.555560,0.663292,0.501395),
                                                new vector(0.519141,0.694853,0.497667)},
                                             new Color[]{Color.RED});
                //System.out.println(""+stack[i].pos.x+","+stack[i].pos.y);
            }
            for(int i = 0;i<stack.length;i++)
            {
                //System.out.println(""+stack[i].pos.x+","+stack[i].pos.y);
            }
        }
        render();
    }
    
    private void render()
    {
        //Clear console
        //System.out.println("\f");
        
        MouseInfo mouse = Greenfoot.getMouseInfo();
        
        //Create Base
        GreenfootImage display = new GreenfootImage(getWorld().getWidth(), getWorld().getHeight());
        display.drawImage(space,0,0);
        
        //Input
        vector newRot = new vector (0f,0f,0f);
        if(mouse != null)
            newRot = new vector(((float)mouse.getY()-((float)getWorld().getHeight()/2))/50,((float)mouse.getX()-((float)getWorld().getWidth()/2))/50,0f);
        
        //Render objects
        for(int i = 0;i<stack.length;i++)
        {
            for(int index = 0;index<stack[i].verts.length;index++)
                stack[i].verts[index].Rotate(new vector(0f,0f,0f),newRot);
            for(int index = 0;index<stack[i].normals.length;index++)
                stack[i].normals[index].Rotate(new vector(0f,0f,0f),newRot);
            stack[i].render(display);
        }
        
        display.mirrorVertically();
        
        //display.drawString("mouse=("+mouse.getX()+","+mouse.getY()+")",0,215);
        
        setImage(display);
        //System.out.println(""+(count++));
    }
}
