import java.awt.Color;
import java.util.List;

public class vector
{
    public float x, y, z;
    
    public vector(float xVar, float yVar, float zVar)
    {
        x = xVar;
        y = yVar;
        z = zVar;
    }
    
    public vector(double xVar, double yVar, double zVar)
    {
        x = (float)xVar;
        y = (float)yVar;
        z = (float)zVar;
    }
    
    public static vector Add(vector v0, vector v1)
    {
        return new vector(v0.x+v1.x,v0.y+v1.y,v0.z+v1.z);
    }
    
    public static vector Subtract(vector v0, vector v1)
    {
        return new vector(v0.x-v1.x,v0.y-v1.y,v0.z-v1.z);
    }
    
    public static vector Midpoint(vector v0, vector v1)
    {
        return new vector((v0.x+v1.x)/2,(v0.y+v1.y)/2,(v0.z+v1.z)/2);
    }
    
    public static float Dist(vector v0, vector v1)
    {
        float width = v0.x-v1.x;
        float height = v0.y-v1.y;
        float depth = v0.z-v1.z;
        width=(float)Math.sqrt(width*width);
        height=(float)Math.sqrt(height*height);
        depth=(float)Math.sqrt(depth*depth);
        return (float)Math.sqrt(width+height+depth);
    }
    
    private float[] rotPointOnPlane(float xVar, float yVar, float rot)
    {
        double angle;
        if(xVar != 0)
        {
            if(yVar != 0)
            {
                angle = ((float)Math.atan((double)yVar/(double)xVar)*180)/Math.PI;
                if(angle < 0)
                    angle*=-1;
                if(xVar < 0 && yVar > 0)
                    angle=90+(90-angle);
                else if(xVar < 0 && yVar < 0)
                    angle=180+angle;
                else if(xVar > 0 && yVar < 0)
                    angle=270+(90-angle);
                //System.out.println("initAng="+angle);
                angle+=rot;
                //System.out.println("sumAng="+angle);
                //System.out.println("x="+xVar+",y="+yVar);
            }
            else if(xVar < 0)
            {
                angle = 180+rot;
                //System.out.println("x is less than 0");
            }
            else
            {
                angle = rot;
                //System.out.println("x is greater than 0");
            }
        }
        else
        {
            if(yVar < 0)
            {
                angle = 270+rot;
                //System.out.println("y is less than 0");
            }
            else
            {
                angle = 90+rot;
                //System.out.println("y is greater than 0");
            }
        }
        
        //if(yVar == 0 || xVar == 0)
        //{
            int quadrant;
            float hypot;
            if(angle >= 360)
                while(angle >= 360)
                    angle-=360;
            else if(angle < 0)
                while(angle < 0)
                    angle+=360;
            //System.out.println(""+angle);
            if(angle < 90)
            {
                quadrant = 1;
                
                //System.out.println("quadrant 1");
            }
            else if(angle < 180)
            {
                quadrant = 2;
                angle = 90-(angle-90);
                //System.out.println("quadrant 2");
            }
            else if(angle < 270)
            {
                quadrant = 3;
                angle = angle-180;
                //System.out.println("quadrant 3");
            }
            else
            {
                quadrant = 4;
                angle = 90-(angle-270);
                //System.out.println("quadrant 4");
            }
            //System.out.println(""+angle);
            hypot = (float)Math.sqrt((xVar*xVar)+(yVar*yVar));
            float angRad = (float)(angle*Math.PI)/180;
            xVar = (float)Math.cos(angRad)*hypot;
            yVar = (float)Math.sin(angRad)*hypot;
            if(quadrant == 2)
                xVar*=-1;
            else if(quadrant == 3)
            {
                xVar*=-1;
                yVar*=-1;
            }
            else if(quadrant == 4)
                yVar*=-1;
            //System.out.println("x="+xVar+",y="+yVar);
            return new float[]{xVar,yVar};
    }
    
    public void Rotate(vector pivot, vector rot)
    {
        vector point = new vector(x,y,z);
        
        point=Subtract(point,pivot);
        
        float[] rotatedPoint = rotPointOnPlane(point.x,point.y,rot.z);
        point.x = rotatedPoint[0];
        point.y = rotatedPoint[1];
        rotatedPoint = rotPointOnPlane(point.x,point.z,rot.y);
        point.x = rotatedPoint[0];
        point.z = rotatedPoint[1];
        rotatedPoint = rotPointOnPlane(point.z,point.y,rot.x);
        point.z = rotatedPoint[0];
        point.y = rotatedPoint[1];
        
        point=Add(point,pivot);
        x = point.x;
        y = point.y;
        z = point.z;
    }
    
    private float dot(vector v0, vector v1)
    {
        return (v0.x*v1.x)+(v0.y*v1.y)+(v0.z*v1.z);
    }
}
